diff --git a/game/core/src/main/java/net/minecraft/core/current/util/BlockState.java b/game/core/src/main/java/net/minecraft/core/current/util/BlockState.java
index 1e87b735c..0c41ed3f4 100644
--- a/game/core/src/main/java/net/minecraft/core/current/util/BlockState.java
+++ b/game/core/src/main/java/net/minecraft/core/current/util/BlockState.java
@@ -4,7 +4,7 @@ package net.minecraft.core.current.util;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
 
 public class BlockState {
@@ -78,11 +78,11 @@ public class BlockState {
 	}
 
 	public boolean hasSignal(World world, BlockPos pos, Direction dir) {
-		return block.getSignal(world, pos.x, pos.y, pos.z, Side.getSideById(dir.index));
+		return block.getSignal(world, pos.x, pos.y, pos.z, dir.getSide());
 	}
 
 	public boolean hasDirectSignal(World world, BlockPos pos, Direction dir) {
-		return block.getDirectSignal(world, pos.x, pos.y, pos.z, Side.getSideById(dir.index));
+		return block.getDirectSignal(world, pos.x, pos.y, pos.z, dir.getSide());
 	}
 
 	public boolean canSurvive(World world, BlockPos pos) {
diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/Node.java b/game/core/src/main/java/net/minecraft/core/current/wire/Node.java
index 1159096fc..c85086c80 100644
--- a/game/core/src/main/java/net/minecraft/core/current/wire/Node.java
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/Node.java
@@ -1,8 +1,8 @@
 package net.minecraft.core.current.wire;
 
+import net.minecraft.core.current.wire.WireHandler.Directions;
 import net.minecraft.core.current.util.BlockPos;
 import net.minecraft.core.current.util.BlockState;
-import net.minecraft.core.current.wire.WireHandler.Directions;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.Blocks;
 
@@ -14,7 +14,7 @@ import java.util.Arrays;
  *
  * @author Space Walker
  */
-public class Node {
+class Node {
 
 	// flags that encode the Node type
 	private static final int CONDUCTOR = 0b01;
diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/PriorityQueue.java b/game/core/src/main/java/net/minecraft/core/current/wire/PriorityQueue.java
index 32000d8b1..5f38cce11 100644
--- a/game/core/src/main/java/net/minecraft/core/current/wire/PriorityQueue.java
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/PriorityQueue.java
@@ -1,14 +1,15 @@
 package net.minecraft.core.current.wire;
 
-import net.minecraft.core.current.util.Redstone;
+import net.minecraft.core.block.BlockLogicWireRedstone;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.AbstractQueue;
 import java.util.Arrays;
 import java.util.Iterator;
 
-public class PriorityQueue extends AbstractQueue<Node> {
+class PriorityQueue extends AbstractQueue<Node> {
 
-	private static final int OFFSET = -Redstone.SIGNAL_MIN;
+	private static final int OFFSET = -BlockLogicWireRedstone.SIGNAL_MIN;
 
 	/** The last node for each priority value. */
 	private final Node[] tails;
@@ -19,7 +20,7 @@ public class PriorityQueue extends AbstractQueue<Node> {
 	private int size;
 
 	PriorityQueue() {
-		this.tails = new Node[(Redstone.SIGNAL_MAX + OFFSET) + 1];
+		this.tails = new Node[(BlockLogicWireRedstone.SIGNAL_MAX + OFFSET) + 1];
 	}
 
 	@Override
@@ -98,7 +99,7 @@ public class PriorityQueue extends AbstractQueue<Node> {
 	}
 
 	@Override
-	public Iterator<Node> iterator() {
+	public @NotNull Iterator<Node> iterator() {
 		throw new UnsupportedOperationException();
 	}
 
diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/SimpleQueue.java b/game/core/src/main/java/net/minecraft/core/current/wire/SimpleQueue.java
index 405861d9c..0fcef5f66 100644
--- a/game/core/src/main/java/net/minecraft/core/current/wire/SimpleQueue.java
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/SimpleQueue.java
@@ -3,7 +3,7 @@ package net.minecraft.core.current.wire;
 import java.util.AbstractQueue;
 import java.util.Iterator;
 
-public class SimpleQueue extends AbstractQueue<WireNode> {
+class SimpleQueue extends AbstractQueue<WireNode> {
 
 	private WireNode head;
 	private WireNode tail;
diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/WireConnection.java b/game/core/src/main/java/net/minecraft/core/current/wire/WireConnection.java
index 86c6fa7bd..b2bb579e0 100644
--- a/game/core/src/main/java/net/minecraft/core/current/wire/WireConnection.java
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/WireConnection.java
@@ -7,7 +7,7 @@ package net.minecraft.core.current.wire;
  * 
  * @author Space Walker
  */
-public class WireConnection {
+class WireConnection {
 
 	/** The connected wire. */
 	final WireNode wire;
diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/WireConnectionManager.java b/game/core/src/main/java/net/minecraft/core/current/wire/WireConnectionManager.java
index 85f14e5c9..a1309f169 100644
--- a/game/core/src/main/java/net/minecraft/core/current/wire/WireConnectionManager.java
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/WireConnectionManager.java
@@ -6,7 +6,7 @@ import net.minecraft.core.current.wire.WireHandler.NodeProvider;
 import java.util.Arrays;
 import java.util.function.Consumer;
 
-public class WireConnectionManager {
+class WireConnectionManager {
 
 	/** The owner of these connections. */
 	final WireNode owner;
diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/WireHandler.java b/game/core/src/main/java/net/minecraft/core/current/wire/WireHandler.java
index d72950e5b..7e9ed8c90 100644
--- a/game/core/src/main/java/net/minecraft/core/current/wire/WireHandler.java
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/WireHandler.java
@@ -1,11 +1,11 @@
 package net.minecraft.core.current.wire;
 
-import net.minecraft.core.current.util.BlockPos;
-import net.minecraft.core.current.util.BlockState;
-import net.minecraft.core.current.util.Direction;
-import net.minecraft.core.current.util.Redstone;
+import net.minecraft.core.block.BlockLogicWireRedstone;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.current.util.BlockPos;
+import net.minecraft.core.current.util.BlockState;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
 
 import java.util.HashMap;
@@ -255,9 +255,9 @@ public class WireHandler {
 	 */
 	static final int[] DEFAULT_CARDINAL_UPDATE_ORDER = CARDINAL_UPDATE_ORDERS[0];
 
-	private static final int POWER_MIN = Redstone.SIGNAL_MIN;
-	private static final int POWER_MAX = Redstone.SIGNAL_MAX;
-	private static final int POWER_STEP = Redstone.SIGNAL_STEP;
+	private static final int POWER_MIN = BlockLogicWireRedstone.SIGNAL_MIN;
+	private static final int POWER_MAX = BlockLogicWireRedstone.SIGNAL_MAX;
+	private static final int POWER_STEP = BlockLogicWireRedstone.SIGNAL_STEP;
 
 	// If Vanilla will ever multi-thread the ticking of worlds, there should
 	// be only one WireHandler per world, in case redstone updates in multiple
@@ -745,7 +745,7 @@ public class WireHandler {
 			return;
 		}
 
-		wire.externalPower = hasExternalPower(wire) ? Redstone.SIGNAL_MAX : Redstone.SIGNAL_MIN;
+		wire.externalPower = hasExternalPower(wire) ? BlockLogicWireRedstone.SIGNAL_MAX : BlockLogicWireRedstone.SIGNAL_MIN;
 
 		if (wire.externalPower > wire.virtualPower) {
 			wire.virtualPower = wire.externalPower;
diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/WireNode.java b/game/core/src/main/java/net/minecraft/core/current/wire/WireNode.java
index 69790e1f7..a323dc284 100644
--- a/game/core/src/main/java/net/minecraft/core/current/wire/WireNode.java
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/WireNode.java
@@ -2,11 +2,10 @@ package net.minecraft.core.current.wire;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.core.block.BlockLogicWireRedstone;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.current.util.BlockPos;
 import net.minecraft.core.current.util.BlockState;
-import net.minecraft.core.current.util.Mth;
-import net.minecraft.core.current.util.Redstone;
-import net.minecraft.core.block.Blocks;
+import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import org.slf4j.Logger;
 
@@ -17,7 +16,7 @@ import org.slf4j.Logger;
  *
  * @author Space Walker
  */
-public class WireNode extends Node {
+class WireNode extends Node {
 	private static final Logger LOGGER = LogUtils.getLogger();
 
 	final WireConnectionManager connections;
@@ -69,7 +68,7 @@ public class WireNode extends Node {
 
 	@Override
 	int priority() {
-		return Mth.clamp(virtualPower, Redstone.SIGNAL_MIN, Redstone.SIGNAL_MAX);
+		return MathHelper.clamp(virtualPower, BlockLogicWireRedstone.SIGNAL_MIN, BlockLogicWireRedstone.SIGNAL_MAX);
 	}
 
 	@Override
@@ -119,7 +118,7 @@ public class WireNode extends Node {
 			return true;
 		}
 
-		currentPower = Mth.clamp(virtualPower, Redstone.SIGNAL_MIN, Redstone.SIGNAL_MAX);
+		currentPower = MathHelper.clamp(virtualPower, BlockLogicWireRedstone.SIGNAL_MIN, BlockLogicWireRedstone.SIGNAL_MAX);
 		state = state.set(currentPower | direction);
 
 		return WorldHelper.setWireState(world, pos, state);
diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/WorldHelper.java b/game/core/src/main/java/net/minecraft/core/current/wire/WorldHelper.java
index 939a59990..37d1c3e0f 100644
--- a/game/core/src/main/java/net/minecraft/core/current/wire/WorldHelper.java
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/WorldHelper.java
@@ -4,7 +4,7 @@ import net.minecraft.core.current.util.BlockPos;
 import net.minecraft.core.current.util.BlockState;
 import net.minecraft.core.world.World;
 
-public class WorldHelper {
+class WorldHelper {
 
 	private static final int Y_MIN = 0;
 
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Entity.java b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
index 659f3516a..067fb5261 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
@@ -1091,7 +1091,7 @@ public abstract class Entity
 
     public boolean save(@NotNull CompoundTag tag)
     {
-        @Nullable NamespaceID s = getEncodeId();
+        @Nullable NamespaceID s = getDispatcherId();
         if(removed || s == null)
         {
             return false;
@@ -1153,9 +1153,13 @@ public abstract class Entity
         readAdditionalSaveData(tag);
     }
 
-    protected final @Nullable NamespaceID getEncodeId()
+    public final @Nullable NamespaceID getDispatcherId()
     {
-        return EntityDispatcher.idForClass(this.getClass());
+        EntityDispatcher.EntityDispatcherEntry<?> entry = EntityDispatcher.getInstance().entryForClass(this.getClass());
+        if (entry != null) {
+            return entry.namespaceID;
+        }
+        return null;
     }
 
     public abstract void readAdditionalSaveData(@NotNull CompoundTag tag);
@@ -1604,11 +1608,13 @@ public abstract class Entity
         if (entity instanceof Player){
             return ((Player) entity).getDisplayName();
         }
-        if (EntityDispatcher.nameKeyForClass(entity.getClass()) != null){
-            return translator.translateKey(EntityDispatcher.nameKeyForClass(entity.getClass()));
+        EntityDispatcher.EntityDispatcherEntry<?> entry = EntityDispatcher.getInstance().entryForClass(entity.getClass());
+        if (entry != null) {
+            if (entry.nameKey != null){
+                return translator.translateKey(entry.nameKey);
+            }
+            return entry.namespaceID.value();
         }
-        NamespaceID dispatcherId = EntityDispatcher.idForClass(entity.getClass());
-        if (dispatcherId != null) return dispatcherId.value();
         return entity.getClass().getSimpleName();
     }
 }
